From 6a814fc2219da84b3f80c43939fc1dbed42e12fa Mon Sep 17 00:00:00 2001
From: Richard Guo <guofenglinux@gmail.com>
Date: Tue, 27 Dec 2022 14:45:06 +0800
Subject: [PATCH v1] Skip building eqfunctions for empty grouping set

---
 src/backend/executor/nodeAgg.c | 4 ++++
 1 file changed, 4 insertions(+)

diff --git a/src/backend/executor/nodeAgg.c b/src/backend/executor/nodeAgg.c
index 30c9143183..b5f9f71a7b 100644
--- a/src/backend/executor/nodeAgg.c
+++ b/src/backend/executor/nodeAgg.c
@@ -3494,6 +3494,10 @@ ExecInitAgg(Agg *node, EState *estate, int eflags)
 				{
 					int			length = phasedata->gset_lengths[k];
 
+					/* skip empty grouping set */
+					if (length == 0)
+						continue;
+
 					if (phasedata->eqfunctions[length - 1] != NULL)
 						continue;
 
-- 
2.31.0

